import * as About from '@/common/about.js'
import * as Config from '@/common/config.js'
import * as Utils from '@/common/utils.js'
import * as Storage from '@/common/storage.js'

export const search = (params) => {
    return httpGet('/search', params)
}

export const getSiteSetting = () => {
    return httpGet('/setting/site')
}

export const getPointSetting = () => {
    return httpGet('/setting/point')
}

export const getLicenseInfo = () => {
    return httpGet('/license/info')
}

export const getSocketInfo = () => {
    return httpGet('/socket/info')
}

export const getSecurityQuestions = () => {
    return httpGet('/security/questions')
}

export const getHelpList = () => {
    return httpGet('/help/list')
}

export const getHelpInfo = (id) => {
    return httpGet(`/help/${id}/info`)
}

export const getPageInfo = (id) => {
    return httpGet(`/page/${id}/info`)
}

export const getIndexSlides = () => {
    return httpGet('/index/slides')
}

export const getIndexLives = () => {
    return httpGet('/index/lives')
}

export const getIndexTeachers = () => {
    return httpGet('/index/teachers')
}

export const getIndexArticles = () => {
    return httpGet('/index/articles')
}

export const getIndexQuestions = () => {
    return httpGet('/index/questions')
}

export const getIndexNewCourses = () => {
    return httpGet('/index/courses/new')
}

export const getIndexPopularCourses = () => {
    return httpGet('/index/courses/popular')
}

export const getIndexFeaturedCourses = () => {
    return httpGet('/index/courses/featured')
}

export const getExamPaperCategories = () => {
    return httpGet('/exam/paper/categories')
}

export const getExamPaperList = (params = {}) => {
    return httpGet('/exam/paper/list', params)
}

export const getExamPaperInfo = (id) => {
    return httpGet(`/exam/paper/${id}/info`)
}

export const getExamPaperHistory = (id, params = {}) => {
    return httpGet(`/exam/paper/${id}/history`, params)
}

export const favoriteExamPaper = (id) => {
    return httpPost(`/exam/paper/${id}/favorite`)
}

export const redeemExamPaper = (id) => {
    return httpPost(`/exam/paper/${id}/redeem`)
}

export const joinExamPaper = (id) => {
    return httpPost(`/exam/paper/${id}/join`)
}

export const getExamPaperMockHistory = (id, params = {}) => {
    return httpGet(`/exam/paper/${id}/mock/history`, params)
}

export const getMockExamInfo = (id) => {
    return httpGet(`/exam/${id}/mock/info`)
}

export const getUnitExamInfo = (id) => {
    return httpGet(`/exam/${id}/unit/info`)
}

export const getUnitExamFreshQuestions = (id, params = {}) => {
    return httpGet(`/exam/${id}/unit/questions/fresh`, params)
}

export const getUnitExamHistoryQuestions = (id, params = {}) => {
    return httpGet(`/exam/${id}/unit/questions/history`, params)
}

export const getMistakeExamQuestions = (params = {}) => {
    return httpGet(`/exam/mistake/questions`, params)
}

export const getFavoriteExamQuestions = (params = {}) => {
    return httpGet(`/exam/favorite/questions`, params)
}

export const submitMockExamPaper = (id, params = {}) => {
    return httpPost(`/exam/${id}/mock/paper/submit`, params)
}

export const submitMockExamAnswer = (id, params = {}) => {
    return httpPost(`/exam/${id}/mock/answer/submit`, params)
}

export const submitUnitExamAnswer = (id, params = {}) => {
    return httpPost(`/exam/${id}/unit/answer/submit`, params)
}

export const resetUnitExam = (id) => {
    return httpPost(`/exam/${id}/unit/reset`)
}

export const getExamQuestionInfo = (id) => {
    return httpGet(`/exam/question/${id}/info`)
}

export const checkExamQuestionAnswer = (id, params = {}) => {
    return httpPost(`/exam/question/${id}/answer/check`, params)
}

export const favoriteExamQuestion = (id) => {
    return httpPost(`/exam/question/${id}/favorite`)
}

export const mistakeExamQuestion = (id) => {
    return httpPost(`/exam/question/${id}/mistake`)
}

export const getArticleCategories = () => {
    return httpGet('/article/categories')
}

export const getArticleTags = () => {
    return httpGet('/article/tags')
}

export const getArticleList = (params = {}) => {
    return httpGet('/article/list', params)
}

export const getArticleInfo = (id) => {
    return httpGet(`/article/${id}/info`)
}

export const getArticleComments = (id, params = {}) => {
    return httpGet(`/article/${id}/comments`, params)
}

export const createArticle = (params = {}) => {
    return httpPost('/article/create', params)
}

export const favoriteArticle = (id) => {
    return httpPost(`/article/${id}/favorite`)
}

export const likeArticle = (id) => {
    return httpPost(`/article/${id}/like`)
}

export const deleteArticle = (id) => {
    return httpPost(`/article/${id}/delete`)
}

export const getQuestionCategories = () => {
    return httpGet('/question/categories')
}

export const getQuestionTags = () => {
    return httpGet('/question/tags')
}

export const getQuestionList = (params = {}) => {
    return httpGet('/question/list', params)
}

export const getQuestionInfo = (id) => {
    return httpGet(`/question/${id}/info`)
}

export const getQuestionAnswers = (id, params = {}) => {
    return httpGet(`/question/${id}/answers`, params)
}

export const getQuestionComments = (id, params = {}) => {
    return httpGet(`/question/${id}/comments`, params)
}

export const createQuestion = (params = {}) => {
    return httpPost('/question/create', params)
}

export const favoriteQuestion = (id) => {
    return httpPost(`/question/${id}/favorite`)
}

export const likeQuestion = (id) => {
    return httpPost(`/question/${id}/like`)
}

export const deleteQuestion = (id) => {
    return httpPost(`/question/${id}/delete`)
}

export const getAnswerInfo = (id) => {
    return httpGet(`/answer/${id}/info`)
}

export const getAnswerComments = (id, params = {}) => {
    return httpGet(`/answer/${id}/comments`, params)
}

export const createAnswer = (params = {}) => {
    return httpPost('/answer/create', params)
}

export const likeAnswer = (id) => {
    return httpPost(`/answer/${id}/like`)
}

export const deleteAnswer = (id) => {
    return httpPost(`/answer/${id}/delete`)
}

export const getCommentInfo = (id) => {
    return httpGet(`/comment/${id}/info`)
}

export const getCommentReplies = (id, params = {}) => {
    return httpGet(`/comment/${id}/replies`, params)
}

export const createDanmu = (params = {}) => {
    return httpPost('/danmu/create', params)
}

export const createComment = (params = {}) => {
    return httpPost('/comment/create', params)
}

export const replyComment = (id, params = {}) => {
    return httpPost(`/comment/${id}/reply`, params)
}

export const likeComment = (id) => {
    return httpPost(`/comment/${id}/like`)
}

export const deleteComment = (id) => {
    return httpPost(`/comment/${id}/delete`)
}

export const getCourseCategories = () => {
    return httpGet('/course/categories')
}

export const getCourseTags = () => {
    return httpGet('/course/tags')
}

export const getCourseList = (params = {}) => {
    return httpGet('/course/list', params)
}

export const getCourseInfo = (id) => {
    return httpGet(`/course/${id}/info`)
}

export const getCoursePoster = (id) => {
    return httpGet(`/course/${id}/poster`)
}

export const getCourseChapters = (id) => {
    return httpGet(`/course/${id}/chapters`)
}

export const getCourseExams = (id) => {
    return httpGet(`/course/${id}/exams`)
}

export const getCourseReviews = (id, params = {}) => {
    return httpGet(`/course/${id}/reviews`, params)
}

export const favoriteCourse = (id) => {
    return httpPost(`/course/${id}/favorite`)
}

export const redeemCourse = (id) => {
    return httpPost(`/course/${id}/redeem`)
}

export const getChapterInfo = (id) => {
    return httpGet(`/chapter/${id}/info`)
}

export const getChapterDanmus = (id, params = {}) => {
    return httpGet(`/chapter/${id}/danmus`, params)
}

export const getChapterComments = (id, params = {}) => {
    return httpGet(`/chapter/${id}/comments`, params)
}

export const getChapterResources = (id) => {
    return httpGet(`/chapter/${id}/resources`)
}

export const likeChapter = (id) => {
    return httpPost(`/chapter/${id}/like`)
}

export const learningChapter = (id, params) => {
    return httpPost(`/chapter/${id}/learning`, params)
}

export const getLiveList = (params) => {
    return httpGet('/live/list', params)
}

export const getLiveChats = (id) => {
    return httpGet(`/live/${id}/chats`)
}

export const bindLiveUser = (id, params) => {
    return httpPost(`/live/${id}/user/bind`, params)
}

export const sendLiveMessage = (id, params) => {
    return httpPost(`/live/${id}/msg/send`, params)
}

export const createReview = (params) => {
    return httpPost('/review/create', params)
}

export const getReviewInfo = (id) => {
    return httpGet(`/review/${id}/info`)
}

export const updateReview = (id, params) => {
    return httpPost(`/review/${id}/update`, params)
}

export const deleteReview = (id) => {
    return httpPost(`/review/${id}/delete`)
}

export const likeReview = (id) => {
    return httpPost(`/review/${id}/like`)
}

export const unlikeReview = (id) => {
    return httpPost(`/review/${id}/unlike`)
}

export const getTeacherList = (params = {}) => {
    return httpGet('/teacher/list', params)
}

export const getTeacherInfo = (id) => {
    return httpGet(`/teacher/${id}/info`)
}

export const getTeacherCourses = (id, params = {}) => {
    return httpGet(`/teacher/${id}/courses`, params)
}

export const getUserInfo = (id) => {
    return httpGet(`/user/${id}/info`)
}

export const getUserCourses = (id, params = {}) => {
    return httpGet(`/user/${id}/courses`, params)
}

export const getUserArticles = (id, params = {}) => {
    return httpGet(`/user/${id}/articles`, params)
}

export const getUserQuestions = (id, params = {}) => {
    return httpGet(`/user/${id}/questions`, params)
}

export const getUserAnswers = (id, params = {}) => {
    return httpGet(`/user/${id}/answers`, params)
}

export const getUserFavorites = (id, params = {}) => {
    return httpGet(`/user/${id}/favorites`, params)
}

export const getMyProfile = () => {
    return httpGet('/uc/profile')
}

export const getMyAccount = () => {
    return httpGet('/uc/account')
}

export const getMyPointHistory = (params = {}) => {
    return httpGet('/uc/point/history', params)
}

export const getMyExams = (params = {}) => {
    return httpGet('/uc/exams', params)
}

export const getMyCourses = (params = {}) => {
    return httpGet('/uc/courses', params)
}

export const getMyArticles = (params = {}) => {
    return httpGet('/uc/articles', params)
}

export const getMyQuestions = (params = {}) => {
    return httpGet('/uc/questions', params)
}

export const getMyReviews = (params = {}) => {
    return httpGet('/uc/reviews', params)
}

export const getMyFavorites = (params = {}) => {
    return httpGet('/uc/favorites', params)
}

export const getMyNotifications = (params = {}) => {
    return httpGet('/uc/notifications', params)
}

export const getMyNotifyStats = (params = {}) => {
    return httpGet('/uc/notify/stats', params)
}

export const updateMyProfile = (params = {}) => {
    return httpPost('/uc/profile/update', params)
}

export const registerAccount = (params = {}) => {
    return httpPost('/account/register', params)
}

export const loginAccount = (params = {}) => {
    return httpPost('/account/login', params)
}

export const logoutAccount = (params = {}) => {
    return httpPost('/account/logout', params)
}

export const resetPassword = (params = {}) => {
    return httpPost('/account/password/reset', params)
}

export const updateEmail = (params = {}) => {
    return httpPost('/account/email/update', params)
}

export const updatePassword = (params = {}) => {
    return httpPost('/account/password/update', params)
}

export const uploadAvatar = (filePath) => {
    return new Promise((resolve, reject) => {
        uni.uploadFile({
            url: Config.apiBaseUrl + '/upload/avatar/img',
            name: 'file',
            filePath: filePath,
            success: (res) => {
                resolve(res)
            },
            fail: (e) => {
                reject(e)
            }
        })
    })
}

const httpGet = (path, params = {}, header = {}) => {
    return httpRequest(path, params, 'GET', header)
}

const httpPost = (path, params = {}, header = {}) => {
    return httpRequest(path, params, 'POST', header)
}

const httpRequest = (path, params = {}, method = 'GET', header = {}) => {

    let url = Config.apiBaseUrl + path

    header['X-Version'] = About.appInfo.version
    header['X-Platform'] = Utils.getPlatform()
    header['X-Timestamp'] = Utils.getNowTime()
    header['X-Token'] = Storage.get(Storage.cacheKey.token)
    header['X-Referer'] = Storage.get(Storage.cacheKey.referer)

    return new Promise(function(resolve, reject) {
        uni.request({
            url: url,
            data: params,
            method: method,
            header: header,
            success: function(res) {
                if (res.statusCode == 200) {
                    if (res.data.code == 0) {
                        resolve(res.data)
                    } else {
                        reject(res.data)
                    }
                } else if (res.statusCode == 401) {
                    Utils.clearToken()
                    uni.navigateTo({
                        url: '/pages/account/login'
                    })
                } else {
                    reject(res.data)
                }
            },
            fail: function(err) {
                reject(err)
            }
        })
    })
}
